ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/AnyEvent/lib/AnyEvent.pm
(Generate patch)

Comparing AnyEvent/lib/AnyEvent.pm (file contents):
Revision 1.251 by root, Mon Jul 20 22:39:57 2009 UTC vs.
Revision 1.267 by root, Thu Jul 30 03:46:12 2009 UTC

1=head1 NAME 1=head1 NAME
2 2
3AnyEvent - events independent of event loop implementation 3AnyEvent - the DBI of event loop programming
4 4
5EV, Event, Glib, Tk, Perl, Event::Lib, Qt and POE are various supported 5EV, Event, Glib, Tk, Perl, Event::Lib, Irssi, rxvt-unicode, IO::Async, Qt
6event loops. 6and POE are various supported event loops/environments.
7 7
8=head1 SYNOPSIS 8=head1 SYNOPSIS
9 9
10 use AnyEvent; 10 use AnyEvent;
11 11
47 47
48There is a mailinglist for discussing all things AnyEvent, and an IRC 48There is a mailinglist for discussing all things AnyEvent, and an IRC
49channel, too. 49channel, too.
50 50
51See the AnyEvent project page at the B<Schmorpforge Ta-Sa Software 51See the AnyEvent project page at the B<Schmorpforge Ta-Sa Software
52Respository>, at L<http://anyevent.schmorp.de>, for more info. 52Repository>, at L<http://anyevent.schmorp.de>, for more info.
53 53
54=head1 WHY YOU SHOULD USE THIS MODULE (OR NOT) 54=head1 WHY YOU SHOULD USE THIS MODULE (OR NOT)
55 55
56Glib, POE, IO::Async, Event... CPAN offers event models by the dozen 56Glib, POE, IO::Async, Event... CPAN offers event models by the dozen
57nowadays. So what is different about AnyEvent? 57nowadays. So what is different about AnyEvent?
181my variables are only visible after the statement in which they are 181my variables are only visible after the statement in which they are
182declared. 182declared.
183 183
184=head2 I/O WATCHERS 184=head2 I/O WATCHERS
185 185
186 $w = AnyEvent->io (
187 fh => <filehandle_or_fileno>,
188 poll => <"r" or "w">,
189 cb => <callback>,
190 );
191
186You can create an I/O watcher by calling the C<< AnyEvent->io >> method 192You can create an I/O watcher by calling the C<< AnyEvent->io >> method
187with the following mandatory key-value pairs as arguments: 193with the following mandatory key-value pairs as arguments:
188 194
189C<fh> is the Perl I<file handle> (or a naked file descriptor) to watch 195C<fh> is the Perl I<file handle> (or a naked file descriptor) to watch
190for events (AnyEvent might or might not keep a reference to this file 196for events (AnyEvent might or might not keep a reference to this file
219 undef $w; 225 undef $w;
220 }); 226 });
221 227
222=head2 TIME WATCHERS 228=head2 TIME WATCHERS
223 229
230 $w = AnyEvent->timer (after => <seconds>, cb => <callback>);
231
232 $w = AnyEvent->timer (
233 after => <fractional_seconds>,
234 interval => <fractional_seconds>,
235 cb => <callback>,
236 );
237
224You can create a time watcher by calling the C<< AnyEvent->timer >> 238You can create a time watcher by calling the C<< AnyEvent->timer >>
225method with the following mandatory arguments: 239method with the following mandatory arguments:
226 240
227C<after> specifies after how many seconds (fractional values are 241C<after> specifies after how many seconds (fractional values are
228supported) the callback should be invoked. C<cb> is the callback to invoke 242supported) the callback should be invoked. C<cb> is the callback to invoke
355 369
356=back 370=back
357 371
358=head2 SIGNAL WATCHERS 372=head2 SIGNAL WATCHERS
359 373
374 $w = AnyEvent->signal (signal => <uppercase_signal_name>, cb => <callback>);
375
360You can watch for signals using a signal watcher, C<signal> is the signal 376You can watch for signals using a signal watcher, C<signal> is the signal
361I<name> in uppercase and without any C<SIG> prefix, C<cb> is the Perl 377I<name> in uppercase and without any C<SIG> prefix, C<cb> is the Perl
362callback to be invoked whenever a signal occurs. 378callback to be invoked whenever a signal occurs.
363 379
364Although the callback might get passed parameters, their value and 380Although the callback might get passed parameters, their value and
383 my $w = AnyEvent->signal (signal => "INT", cb => sub { exit 1 }); 399 my $w = AnyEvent->signal (signal => "INT", cb => sub { exit 1 });
384 400
385=head3 Signal Races, Delays and Workarounds 401=head3 Signal Races, Delays and Workarounds
386 402
387Many event loops (e.g. Glib, Tk, Qt, IO::Async) do not support attaching 403Many event loops (e.g. Glib, Tk, Qt, IO::Async) do not support attaching
388callbacks to signals in a generic way, which is a pity, as you cannot do 404callbacks to signals in a generic way, which is a pity, as you cannot
389race-free signal handling in perl. AnyEvent will try to do it's best, but 405do race-free signal handling in perl, requiring C libraries for
406this. AnyEvent will try to do it's best, which means in some cases,
390in some cases, signals will be delayed. The maximum time a signal might 407signals will be delayed. The maximum time a signal might be delayed is
391be delayed is specified in C<$AnyEvent::MAX_SIGNAL_LATENCY> (default: 10 408specified in C<$AnyEvent::MAX_SIGNAL_LATENCY> (default: 10 seconds). This
392seconds). This variable can be changed only before the first signal 409variable can be changed only before the first signal watcher is created,
393watcher is created, and should be left alone otherwise. Higher values 410and should be left alone otherwise. This variable determines how often
411AnyEvent polls for signals (in case a wake-up was missed). Higher values
394will cause fewer spurious wake-ups, which is better for power and CPU 412will cause fewer spurious wake-ups, which is better for power and CPU
413saving.
414
395saving. All these problems can be avoided by installing the optional 415All these problems can be avoided by installing the optional
396L<Async::Interrupt> module. This will not work with inherently broken 416L<Async::Interrupt> module, which works with most event loops. It will not
397event loops such as L<Event> or L<Event::Lib> (and not with L<POE> 417work with inherently broken event loops such as L<Event> or L<Event::Lib>
398currently, as POE does it's own workaround with one-second latency). With 418(and not with L<POE> currently, as POE does it's own workaround with
399those, you just have to suffer the delays. 419one-second latency). For those, you just have to suffer the delays.
400 420
401=head2 CHILD PROCESS WATCHERS 421=head2 CHILD PROCESS WATCHERS
402 422
423 $w = AnyEvent->child (pid => <process id>, cb => <callback>);
424
403You can also watch on a child process exit and catch its exit status. 425You can also watch on a child process exit and catch its exit status.
404 426
405The child process is specified by the C<pid> argument (if set to C<0>, it 427The child process is specified by the C<pid> argument (one some backends,
406watches for any child process exit). The watcher will triggered only when 428using C<0> watches for any child process exit, on others this will
407the child process has finished and an exit status is available, not on 429croak). The watcher will be triggered only when the child process has
408any trace events (stopped/continued). 430finished and an exit status is available, not on any trace events
431(stopped/continued).
409 432
410The callback will be called with the pid and exit status (as returned by 433The callback will be called with the pid and exit status (as returned by
411waitpid), so unlike other watcher types, you I<can> rely on child watcher 434waitpid), so unlike other watcher types, you I<can> rely on child watcher
412callback arguments. 435callback arguments.
413 436
454 # do something else, then wait for process exit 477 # do something else, then wait for process exit
455 $done->recv; 478 $done->recv;
456 479
457=head2 IDLE WATCHERS 480=head2 IDLE WATCHERS
458 481
482 $w = AnyEvent->idle (cb => <callback>);
483
459Sometimes there is a need to do something, but it is not so important 484Sometimes there is a need to do something, but it is not so important
460to do it instantly, but only when there is nothing better to do. This 485to do it instantly, but only when there is nothing better to do. This
461"nothing better to do" is usually defined to be "no other events need 486"nothing better to do" is usually defined to be "no other events need
462attention by the event loop". 487attention by the event loop".
463 488
489 }); 514 });
490 }); 515 });
491 516
492=head2 CONDITION VARIABLES 517=head2 CONDITION VARIABLES
493 518
519 $cv = AnyEvent->condvar;
520
521 $cv->send (<list>);
522 my @res = $cv->recv;
523
494If you are familiar with some event loops you will know that all of them 524If you are familiar with some event loops you will know that all of them
495require you to run some blocking "loop", "run" or similar function that 525require you to run some blocking "loop", "run" or similar function that
496will actively watch for new events and call your callbacks. 526will actively watch for new events and call your callbacks.
497 527
498AnyEvent is slightly different: it expects somebody else to run the event 528AnyEvent is slightly different: it expects somebody else to run the event
796 826
797 AnyEvent::Impl::Glib based on Glib, slow but very stable. 827 AnyEvent::Impl::Glib based on Glib, slow but very stable.
798 AnyEvent::Impl::Tk based on Tk, very broken. 828 AnyEvent::Impl::Tk based on Tk, very broken.
799 AnyEvent::Impl::EventLib based on Event::Lib, leaks memory and worse. 829 AnyEvent::Impl::EventLib based on Event::Lib, leaks memory and worse.
800 AnyEvent::Impl::POE based on POE, very slow, some limitations. 830 AnyEvent::Impl::POE based on POE, very slow, some limitations.
831 AnyEvent::Impl::Irssi used when running within irssi.
801 832
802=item Backends with special needs. 833=item Backends with special needs.
803 834
804Qt requires the Qt::Application to be instantiated first, but will 835Qt requires the Qt::Application to be instantiated first, but will
805otherwise be picked up automatically. As long as the main program 836otherwise be picked up automatically. As long as the main program
879event module detection too early, for example, L<AnyEvent::AIO> creates 910event module detection too early, for example, L<AnyEvent::AIO> creates
880and installs the global L<IO::AIO> watcher in a C<post_detect> block to 911and installs the global L<IO::AIO> watcher in a C<post_detect> block to
881avoid autodetecting the event module at load time. 912avoid autodetecting the event module at load time.
882 913
883If called in scalar or list context, then it creates and returns an object 914If called in scalar or list context, then it creates and returns an object
884that automatically removes the callback again when it is destroyed. See 915that automatically removes the callback again when it is destroyed (or
916C<undef> when the hook was immediately executed). See L<AnyEvent::AIO> for
885L<Coro::BDB> for a case where this is useful. 917a case where this is useful.
918
919Example: Create a watcher for the IO::AIO module and store it in
920C<$WATCHER>. Only do so after the event loop is initialised, though.
921
922 our WATCHER;
923
924 my $guard = AnyEvent::post_detect {
925 $WATCHER = AnyEvent->io (fh => IO::AIO::poll_fileno, poll => 'r', cb => \&IO::AIO::poll_cb);
926 };
927
928 # the ||= is important in case post_detect immediately runs the block,
929 # as to not clobber the newly-created watcher. assigning both watcher and
930 # post_detect guard to the same variable has the advantage of users being
931 # able to just C<undef $WATCHER> if the watcher causes them grief.
932
933 $WATCHER ||= $guard;
886 934
887=item @AnyEvent::post_detect 935=item @AnyEvent::post_detect
888 936
889If there are any code references in this array (you can C<push> to it 937If there are any code references in this array (you can C<push> to it
890before or after loading AnyEvent), then they will called directly after 938before or after loading AnyEvent), then they will called directly after
1067 1115
1068BEGIN { AnyEvent::common_sense } 1116BEGIN { AnyEvent::common_sense }
1069 1117
1070use Carp (); 1118use Carp ();
1071 1119
1072our $VERSION = 4.86; 1120our $VERSION = 4.881;
1073our $MODEL; 1121our $MODEL;
1074 1122
1075our $AUTOLOAD; 1123our $AUTOLOAD;
1076our @ISA; 1124our @ISA;
1077 1125
1102 for reverse split /\s*,\s*/, 1150 for reverse split /\s*,\s*/,
1103 $ENV{PERL_ANYEVENT_PROTOCOLS} || "ipv4,ipv6"; 1151 $ENV{PERL_ANYEVENT_PROTOCOLS} || "ipv4,ipv6";
1104} 1152}
1105 1153
1106my @models = ( 1154my @models = (
1107 [EV:: => AnyEvent::Impl::EV::], 1155 [EV:: => AnyEvent::Impl::EV:: , 1],
1108 [Event:: => AnyEvent::Impl::Event::], 1156 [Event:: => AnyEvent::Impl::Event::, 1],
1109 [AnyEvent::Impl::Perl:: => AnyEvent::Impl::Perl::], 1157 [AnyEvent::Impl::Perl:: => AnyEvent::Impl::Perl:: , 1],
1110 # everything below here will not be autoprobed 1158 # everything below here will not (normally) be autoprobed
1111 # as the pureperl backend should work everywhere 1159 # as the pureperl backend should work everywhere
1112 # and is usually faster 1160 # and is usually faster
1113 [Glib:: => AnyEvent::Impl::Glib::], # becomes extremely slow with many watchers 1161 [Glib:: => AnyEvent::Impl::Glib:: , 1], # becomes extremely slow with many watchers
1114 [Event::Lib:: => AnyEvent::Impl::EventLib::], # too buggy 1162 [Event::Lib:: => AnyEvent::Impl::EventLib::], # too buggy
1163 [Irssi:: => AnyEvent::Impl::Irssi::], # Irssi has a bogus "Event" package
1115 [Tk:: => AnyEvent::Impl::Tk::], # crashes with many handles 1164 [Tk:: => AnyEvent::Impl::Tk::], # crashes with many handles
1116 [Qt:: => AnyEvent::Impl::Qt::], # requires special main program 1165 [Qt:: => AnyEvent::Impl::Qt::], # requires special main program
1117 [POE::Kernel:: => AnyEvent::Impl::POE::], # lasciate ogni speranza 1166 [POE::Kernel:: => AnyEvent::Impl::POE::], # lasciate ogni speranza
1118 [Wx:: => AnyEvent::Impl::POE::], 1167 [Wx:: => AnyEvent::Impl::POE::],
1119 [Prima:: => AnyEvent::Impl::POE::], 1168 [Prima:: => AnyEvent::Impl::POE::],
1120 # IO::Async is just too broken - we would need workarounds for its 1169 # IO::Async is just too broken - we would need workarounds for its
1121 # byzantine signal and broken child handling, among others. 1170 # byzantine signal and broken child handling, among others.
1122 # IO::Async is rather hard to detect, as it doesn't have any 1171 # IO::Async is rather hard to detect, as it doesn't have any
1123 # obvious default class. 1172 # obvious default class.
1124# [IO::Async:: => AnyEvent::Impl::IOAsync::], # requires special main program 1173# [0, IO::Async:: => AnyEvent::Impl::IOAsync::], # requires special main program
1125# [IO::Async::Loop:: => AnyEvent::Impl::IOAsync::], # requires special main program 1174# [0, IO::Async::Loop:: => AnyEvent::Impl::IOAsync::], # requires special main program
1126# [IO::Async::Notifier:: => AnyEvent::Impl::IOAsync::], # requires special main program 1175# [0, IO::Async::Notifier:: => AnyEvent::Impl::IOAsync::], # requires special main program
1127); 1176);
1128 1177
1129our %method = map +($_ => 1), 1178our %method = map +($_ => 1),
1130 qw(io timer time now now_update signal child idle condvar one_event DESTROY); 1179 qw(io timer time now now_update signal child idle condvar one_event DESTROY);
1131 1180
1135 my ($cb) = @_; 1184 my ($cb) = @_;
1136 1185
1137 if ($MODEL) { 1186 if ($MODEL) {
1138 $cb->(); 1187 $cb->();
1139 1188
1140 1 1189 undef
1141 } else { 1190 } else {
1142 push @post_detect, $cb; 1191 push @post_detect, $cb;
1143 1192
1144 defined wantarray 1193 defined wantarray
1145 ? bless \$cb, "AnyEvent::Util::postdetect" 1194 ? bless \$cb, "AnyEvent::Util::postdetect"
1177 } 1226 }
1178 } 1227 }
1179 } 1228 }
1180 1229
1181 unless ($MODEL) { 1230 unless ($MODEL) {
1182 # try to load a model 1231 # try to autoload a model
1183
1184 for (@REGISTRY, @models) { 1232 for (@REGISTRY, @models) {
1185 my ($package, $model) = @$_; 1233 my ($package, $model, $autoload) = @$_;
1234 if (
1235 $autoload
1186 if (eval "require $package" 1236 and eval "require $package"
1187 and ${"$package\::VERSION"} > 0 1237 and ${"$package\::VERSION"} > 0
1188 and eval "require $model") { 1238 and eval "require $model"
1239 ) {
1189 $MODEL = $model; 1240 $MODEL = $model;
1190 warn "AnyEvent: autoprobed model '$model', using it.\n" if $VERBOSE >= 2; 1241 warn "AnyEvent: autoloaded model '$model', using it.\n" if $VERBOSE >= 2;
1191 last; 1242 last;
1192 } 1243 }
1193 } 1244 }
1194 1245
1195 $MODEL 1246 $MODEL
1267} 1318}
1268 1319
1269# default implementation for ->signal 1320# default implementation for ->signal
1270 1321
1271our $HAVE_ASYNC_INTERRUPT; 1322our $HAVE_ASYNC_INTERRUPT;
1323
1324sub _have_async_interrupt() {
1325 $HAVE_ASYNC_INTERRUPT = 1*(!$ENV{PERL_ANYEVENT_AVOID_ASYNC_INTERRUPT}
1326 && eval "use Async::Interrupt 1.0 (); 1")
1327 unless defined $HAVE_ASYNC_INTERRUPT;
1328
1329 $HAVE_ASYNC_INTERRUPT
1330}
1331
1272our ($SIGPIPE_R, $SIGPIPE_W, %SIG_CB, %SIG_EV, $SIG_IO); 1332our ($SIGPIPE_R, $SIGPIPE_W, %SIG_CB, %SIG_EV, $SIG_IO);
1273our (%SIG_ASY, %SIG_ASY_W); 1333our (%SIG_ASY, %SIG_ASY_W);
1274our ($SIG_COUNT, $SIG_TW); 1334our ($SIG_COUNT, $SIG_TW);
1275 1335
1276sub _signal_exec { 1336sub _signal_exec {
1284 $_->() for values %{ $SIG_CB{$_} || {} }; 1344 $_->() for values %{ $SIG_CB{$_} || {} };
1285 } 1345 }
1286 } 1346 }
1287} 1347}
1288 1348
1289# install a dumym wakeupw atcher to reduce signal catching latency 1349# install a dummy wakeup watcher to reduce signal catching latency
1290sub _sig_add() { 1350sub _sig_add() {
1291 unless ($SIG_COUNT++) { 1351 unless ($SIG_COUNT++) {
1292 # try to align timer on a full-second boundary, if possible 1352 # try to align timer on a full-second boundary, if possible
1293 my $NOW = AnyEvent->now; 1353 my $NOW = AnyEvent->now;
1294 1354
1303sub _sig_del { 1363sub _sig_del {
1304 undef $SIG_TW 1364 undef $SIG_TW
1305 unless --$SIG_COUNT; 1365 unless --$SIG_COUNT;
1306} 1366}
1307 1367
1368our $_sig_name_init; $_sig_name_init = sub {
1369 eval q{ # poor man's autoloading
1370 undef $_sig_name_init;
1371
1372 if (_have_async_interrupt) {
1373 *sig2num = \&Async::Interrupt::sig2num;
1374 *sig2name = \&Async::Interrupt::sig2name;
1375 } else {
1376 require Config;
1377
1378 my %signame2num;
1379 @signame2num{ split ' ', $Config::Config{sig_name} }
1380 = split ' ', $Config::Config{sig_num};
1381
1382 my @signum2name;
1383 @signum2name[values %signame2num] = keys %signame2num;
1384
1385 *sig2num = sub($) {
1386 $_[0] > 0 ? shift : $signame2num{+shift}
1387 };
1388 *sig2name = sub ($) {
1389 $_[0] > 0 ? $signum2name[+shift] : shift
1390 };
1391 }
1392 };
1393 die if $@;
1394};
1395
1396sub sig2num ($) { &$_sig_name_init; &sig2num }
1397sub sig2name($) { &$_sig_name_init; &sig2name }
1398
1308sub _signal { 1399sub signal {
1400 eval q{ # poor man's autoloading {}
1401 # probe for availability of Async::Interrupt
1402 if (_have_async_interrupt) {
1403 warn "AnyEvent: using Async::Interrupt for race-free signal handling.\n" if $VERBOSE >= 8;
1404
1405 $SIGPIPE_R = new Async::Interrupt::EventPipe;
1406 $SIG_IO = AnyEvent->io (fh => $SIGPIPE_R->fileno, poll => "r", cb => \&_signal_exec);
1407
1408 } else {
1409 warn "AnyEvent: using emulated perl signal handling with latency timer.\n" if $VERBOSE >= 8;
1410
1411 require Fcntl;
1412
1413 if (AnyEvent::WIN32) {
1414 require AnyEvent::Util;
1415
1416 ($SIGPIPE_R, $SIGPIPE_W) = AnyEvent::Util::portable_pipe ();
1417 AnyEvent::Util::fh_nonblocking ($SIGPIPE_R, 1) if $SIGPIPE_R;
1418 AnyEvent::Util::fh_nonblocking ($SIGPIPE_W, 1) if $SIGPIPE_W; # just in case
1419 } else {
1420 pipe $SIGPIPE_R, $SIGPIPE_W;
1421 fcntl $SIGPIPE_R, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_R;
1422 fcntl $SIGPIPE_W, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_W; # just in case
1423
1424 # not strictly required, as $^F is normally 2, but let's make sure...
1425 fcntl $SIGPIPE_R, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1426 fcntl $SIGPIPE_W, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1427 }
1428
1429 $SIGPIPE_R
1430 or Carp::croak "AnyEvent: unable to create a signal reporting pipe: $!\n";
1431
1432 $SIG_IO = AnyEvent->io (fh => $SIGPIPE_R, poll => "r", cb => \&_signal_exec);
1433 }
1434
1435 *signal = sub {
1309 my (undef, %arg) = @_; 1436 my (undef, %arg) = @_;
1310 1437
1311 my $signal = uc $arg{signal} 1438 my $signal = uc $arg{signal}
1312 or Carp::croak "required option 'signal' is missing"; 1439 or Carp::croak "required option 'signal' is missing";
1313 1440
1314 $SIG_CB{$signal}{$arg{cb}} = $arg{cb};
1315
1316 if ($HAVE_ASYNC_INTERRUPT) { 1441 if ($HAVE_ASYNC_INTERRUPT) {
1317 # async::interrupt 1442 # async::interrupt
1318 1443
1319 $SIG_ASY{$signal} ||= do { 1444 $signal = sig2num $signal;
1320 my $asy = new Async::Interrupt 1445 $SIG_CB{$signal}{$arg{cb}} = $arg{cb};
1446
1447 $SIG_ASY{$signal} ||= new Async::Interrupt
1321 cb => sub { undef $SIG_EV{$signal} }, 1448 cb => sub { undef $SIG_EV{$signal} },
1322 signal => $signal, 1449 signal => $signal,
1323 pipe => [$SIGPIPE_R->filenos], 1450 pipe => [$SIGPIPE_R->filenos],
1451 pipe_autodrain => 0,
1452 ;
1453
1454 } else {
1455 # pure perl
1456
1457 # AE::Util has been loaded in signal
1458 $signal = sig2name $signal;
1459 $SIG_CB{$signal}{$arg{cb}} = $arg{cb};
1460
1461 $SIG{$signal} ||= sub {
1462 local $!;
1463 syswrite $SIGPIPE_W, "\x00", 1 unless %SIG_EV;
1464 undef $SIG_EV{$signal};
1465 };
1466
1467 # can't do signal processing without introducing races in pure perl,
1468 # so limit the signal latency.
1469 _sig_add;
1324 ; 1470 }
1325 $asy->pipe_autodrain (0);
1326 1471
1327 $asy 1472 bless [$signal, $arg{cb}], "AnyEvent::Base::signal"
1328 }; 1473 };
1329 1474
1330 } else { 1475 *AnyEvent::Base::signal::DESTROY = sub {
1331 # pure perl 1476 my ($signal, $cb) = @{$_[0]};
1332 1477
1333 $SIG{$signal} ||= sub { 1478 _sig_del;
1334 local $!; 1479
1335 syswrite $SIGPIPE_W, "\x00", 1 unless %SIG_EV; 1480 delete $SIG_CB{$signal}{$cb};
1481
1482 $HAVE_ASYNC_INTERRUPT
1483 ? delete $SIG_ASY{$signal}
1484 : # delete doesn't work with older perls - they then
1485 # print weird messages, or just unconditionally exit
1486 # instead of getting the default action.
1336 undef $SIG_EV{$signal}; 1487 undef $SIG{$signal}
1488 unless keys %{ $SIG_CB{$signal} };
1337 }; 1489 };
1338
1339 # can't do signal processing without introducing races in pure perl,
1340 # so limit the signal latency.
1341 _sig_add;
1342 } 1490 };
1343 1491 die if $@;
1344 bless [$signal, $arg{cb}], "AnyEvent::Base::signal"
1345}
1346
1347sub signal {
1348 # probe for availability of Async::Interrupt
1349 if (!$ENV{PERL_ANYEVENT_AVOID_ASYNC_INTERRUPT} && eval "use Async::Interrupt 0.6 (); 1") {
1350 warn "AnyEvent: using Async::Interrupt for race-free signal handling.\n" if $VERBOSE >= 8;
1351
1352 $HAVE_ASYNC_INTERRUPT = 1;
1353 $SIGPIPE_R = new Async::Interrupt::EventPipe;
1354 $SIG_IO = AnyEvent->io (fh => $SIGPIPE_R->fileno, poll => "r", cb => \&_signal_exec);
1355
1356 } else {
1357 warn "AnyEvent: using emulated perl signal handling with latency timer.\n" if $VERBOSE >= 8;
1358
1359 require Fcntl;
1360
1361 if (AnyEvent::WIN32) {
1362 require AnyEvent::Util;
1363
1364 ($SIGPIPE_R, $SIGPIPE_W) = AnyEvent::Util::portable_pipe ();
1365 AnyEvent::Util::fh_nonblocking ($SIGPIPE_R) if $SIGPIPE_R;
1366 AnyEvent::Util::fh_nonblocking ($SIGPIPE_W) if $SIGPIPE_W; # just in case
1367 } else {
1368 pipe $SIGPIPE_R, $SIGPIPE_W;
1369 fcntl $SIGPIPE_R, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_R;
1370 fcntl $SIGPIPE_W, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_W; # just in case
1371
1372 # not strictly required, as $^F is normally 2, but let's make sure...
1373 fcntl $SIGPIPE_R, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1374 fcntl $SIGPIPE_W, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1375 }
1376
1377 $SIGPIPE_R
1378 or Carp::croak "AnyEvent: unable to create a signal reporting pipe: $!\n";
1379
1380 $SIG_IO = AnyEvent->io (fh => $SIGPIPE_R, poll => "r", cb => \&_signal_exec);
1381 }
1382
1383 *signal = \&_signal;
1384 &signal 1492 &signal
1385}
1386
1387sub AnyEvent::Base::signal::DESTROY {
1388 my ($signal, $cb) = @{$_[0]};
1389
1390 _sig_del;
1391
1392 delete $SIG_CB{$signal}{$cb};
1393
1394 $HAVE_ASYNC_INTERRUPT
1395 ? delete $SIG_ASY{$signal}
1396 : # delete doesn't work with older perls - they then
1397 # print weird messages, or just unconditionally exit
1398 # instead of getting the default action.
1399 undef $SIG{$signal}
1400 unless keys %{ $SIG_CB{$signal} };
1401} 1493}
1402 1494
1403# default implementation for ->child 1495# default implementation for ->child
1404 1496
1405our %PID_CB; 1497our %PID_CB;
1406our $CHLD_W; 1498our $CHLD_W;
1407our $CHLD_DELAY_W; 1499our $CHLD_DELAY_W;
1408our $WNOHANG; 1500our $WNOHANG;
1409 1501
1502sub _emit_childstatus($$) {
1503 my (undef, $rpid, $rstatus) = @_;
1504
1505 $_->($rpid, $rstatus)
1506 for values %{ $PID_CB{$rpid} || {} },
1507 values %{ $PID_CB{0} || {} };
1508}
1509
1410sub _sigchld { 1510sub _sigchld {
1511 my $pid;
1512
1513 AnyEvent->_emit_childstatus ($pid, $?)
1411 while (0 < (my $pid = waitpid -1, $WNOHANG)) { 1514 while ($pid = waitpid -1, $WNOHANG) > 0;
1412 $_->($pid, $?)
1413 for values %{ $PID_CB{$pid} || {} },
1414 values %{ $PID_CB{0} || {} };
1415 }
1416} 1515}
1417 1516
1418sub child { 1517sub child {
1419 my (undef, %arg) = @_; 1518 my (undef, %arg) = @_;
1420 1519
1552} 1651}
1553 1652
1554# undocumented/compatibility with pre-3.4 1653# undocumented/compatibility with pre-3.4
1555*broadcast = \&send; 1654*broadcast = \&send;
1556*wait = \&_wait; 1655*wait = \&_wait;
1656
1657#############################################################################
1658# "new" API, currently only emulation of it
1659#############################################################################
1660
1661package AE;
1662
1663sub io($$$) {
1664 AnyEvent->io (fh => $_[0], poll => $_[1] ? "w" : "r", cb => $_[2])
1665}
1666
1667sub timer($$$) {
1668 AnyEvent->timer (after => $_[0], interval => $_[1], cb => $_[2]);
1669}
1670
1671sub signal($$) {
1672 AnyEvent->signal (signal => $_[0], cb => $_[1]);
1673}
1674
1675sub child($$) {
1676 AnyEvent->child (pid => $_[0], cb => $_[1]);
1677}
1678
1679sub idle($) {
1680 AnyEvent->idle (cb => $_[0]);
1681}
1682
1683sub cv() {
1684 AnyEvent->condvar
1685}
1686
1687sub now() {
1688 AnyEvent->now
1689}
1690
1691sub now_update() {
1692 AnyEvent->now_update
1693}
1694
1695sub time() {
1696 AnyEvent->time
1697}
1557 1698
1558=head1 ERROR AND EXCEPTION HANDLING 1699=head1 ERROR AND EXCEPTION HANDLING
1559 1700
1560In general, AnyEvent does not do any error handling - it relies on the 1701In general, AnyEvent does not do any error handling - it relies on the
1561caller to do that if required. The L<AnyEvent::Strict> module (see also 1702caller to do that if required. The L<AnyEvent::Strict> module (see also
2399L<Glib>, L<Tk>, L<Event::Lib>, L<Qt>, L<POE>. 2540L<Glib>, L<Tk>, L<Event::Lib>, L<Qt>, L<POE>.
2400 2541
2401Implementations: L<AnyEvent::Impl::EV>, L<AnyEvent::Impl::Event>, 2542Implementations: L<AnyEvent::Impl::EV>, L<AnyEvent::Impl::Event>,
2402L<AnyEvent::Impl::Glib>, L<AnyEvent::Impl::Tk>, L<AnyEvent::Impl::Perl>, 2543L<AnyEvent::Impl::Glib>, L<AnyEvent::Impl::Tk>, L<AnyEvent::Impl::Perl>,
2403L<AnyEvent::Impl::EventLib>, L<AnyEvent::Impl::Qt>, 2544L<AnyEvent::Impl::EventLib>, L<AnyEvent::Impl::Qt>,
2404L<AnyEvent::Impl::POE>, L<AnyEvent::Impl::IOAsync>. 2545L<AnyEvent::Impl::POE>, L<AnyEvent::Impl::IOAsync>, L<Anyevent::Impl::Irssi>.
2405 2546
2406Non-blocking file handles, sockets, TCP clients and 2547Non-blocking file handles, sockets, TCP clients and
2407servers: L<AnyEvent::Handle>, L<AnyEvent::Socket>, L<AnyEvent::TLS>. 2548servers: L<AnyEvent::Handle>, L<AnyEvent::Socket>, L<AnyEvent::TLS>.
2408 2549
2409Asynchronous DNS: L<AnyEvent::DNS>. 2550Asynchronous DNS: L<AnyEvent::DNS>.

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines